diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/bindings/modulegen__gcc_LP64.py ns-3.31/src/buildings/bindings/modulegen__gcc_LP64.py
--- ns-3.30.1/src/buildings/bindings/modulegen__gcc_LP64.py	2019-08-12 17:00:27.000000000 -0700
+++ ns-3.31/src/buildings/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
@@ -6039,7 +6623,7 @@
     cls.add_method('Copy', 
                    'ns3::Ptr< ns3::AttributeValue >', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## vector.h (module 'core'): bool ns3::Vector3DValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
     cls.add_method('DeserializeFromString', 
                    'bool', 
@@ -6054,7 +6638,7 @@
     cls.add_method('SerializeToString', 
                    'std::string', 
                    [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## vector.h (module 'core'): void ns3::Vector3DValue::Set(ns3::Vector3D const & value) [member function]
     cls.add_method('Set', 
                    'void', 
@@ -6079,7 +6663,7 @@
     cls.add_method('Copy', 
                    'ns3::Ptr< ns3::AttributeValue >', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## address.h (module 'network'): bool ns3::AddressValue::DeserializeFromString(std::string value, ns3::Ptr<const ns3::AttributeChecker> checker) [member function]
     cls.add_method('DeserializeFromString', 
                    'bool', 
@@ -6094,13 +6678,53 @@
     cls.add_method('SerializeToString', 
                    'std::string', 
                    [param('ns3::Ptr< ns3::AttributeChecker const >', 'checker')], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## address.h (module 'network'): void ns3::AddressValue::Set(ns3::Address const & value) [member function]
     cls.add_method('Set', 
                    'void', 
                    [param('ns3::Address const &', 'value')])
     return
 
+def register_Ns3AlwaysLosChannelConditionModel_methods(root_module, cls):
+    ## channel-condition-model.h (module 'propagation'): static ns3::TypeId ns3::AlwaysLosChannelConditionModel::GetTypeId() [member function]
+    cls.add_method('GetTypeId', 
+                   'ns3::TypeId', 
+                   [], 
+                   is_static=True)
+    ## channel-condition-model.h (module 'propagation'): ns3::AlwaysLosChannelConditionModel::AlwaysLosChannelConditionModel() [constructor]
+    cls.add_constructor([])
+    ## channel-condition-model.h (module 'propagation'): ns3::Ptr<ns3::ChannelCondition> ns3::AlwaysLosChannelConditionModel::GetChannelCondition(ns3::Ptr<const ns3::MobilityModel> a, ns3::Ptr<const ns3::MobilityModel> b) const [member function]
+    cls.add_method('GetChannelCondition', 
+                   'ns3::Ptr< ns3::ChannelCondition >', 
+                   [param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')], 
+                   is_virtual=True, is_const=True)
+    ## channel-condition-model.h (module 'propagation'): int64_t ns3::AlwaysLosChannelConditionModel::AssignStreams(int64_t stream) [member function]
+    cls.add_method('AssignStreams', 
+                   'int64_t', 
+                   [param('int64_t', 'stream')], 
+                   is_virtual=True)
+    return
+
+def register_Ns3BuildingsChannelConditionModel_methods(root_module, cls):
+    ## buildings-channel-condition-model.h (module 'buildings'): static ns3::TypeId ns3::BuildingsChannelConditionModel::GetTypeId() [member function]
+    cls.add_method('GetTypeId', 
+                   'ns3::TypeId', 
+                   [], 
+                   is_static=True)
+    ## buildings-channel-condition-model.h (module 'buildings'): ns3::BuildingsChannelConditionModel::BuildingsChannelConditionModel() [constructor]
+    cls.add_constructor([])
+    ## buildings-channel-condition-model.h (module 'buildings'): ns3::Ptr<ns3::ChannelCondition> ns3::BuildingsChannelConditionModel::GetChannelCondition(ns3::Ptr<const ns3::MobilityModel> a, ns3::Ptr<const ns3::MobilityModel> b) const [member function]
+    cls.add_method('GetChannelCondition', 
+                   'ns3::Ptr< ns3::ChannelCondition >', 
+                   [param('ns3::Ptr< ns3::MobilityModel const >', 'a'), param('ns3::Ptr< ns3::MobilityModel const >', 'b')], 
+                   is_virtual=True, is_const=True)
+    ## buildings-channel-condition-model.h (module 'buildings'): int64_t ns3::BuildingsChannelConditionModel::AssignStreams(int64_t stream) [member function]
+    cls.add_method('AssignStreams', 
+                   'int64_t', 
+                   [param('int64_t', 'stream')], 
+                   is_virtual=True)
+    return
+
 def register_Ns3CallbackImpl__Ns3ObjectBase___star___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
     ## callback.h (module 'core'): ns3::CallbackImpl<ns3::ObjectBase *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
     cls.add_constructor([])
@@ -6115,7 +6739,7 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## callback.h (module 'core'): ns3::ObjectBase * ns3::CallbackImpl<ns3::ObjectBase *, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()() [member operator]
     cls.add_method('operator()', 
                    'ns3::ObjectBase *', 
@@ -6123,6 +6747,28 @@
                    custom_name='__call__', is_virtual=True, is_pure_virtual=True)
     return
 
+def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3MobilityModel__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
+    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
+    cls.add_constructor([])
+    ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl(ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty> const & arg0) [constructor]
+    cls.add_constructor([param('ns3::CallbackImpl< void, ns3::Ptr< ns3::MobilityModel const >, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty > const &', 'arg0')])
+    ## callback.h (module 'core'): static std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::DoGetTypeid() [member function]
+    cls.add_method('DoGetTypeid', 
+                   'std::string', 
+                   [], 
+                   is_static=True)
+    ## callback.h (module 'core'): std::string ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::GetTypeid() const [member function]
+    cls.add_method('GetTypeid', 
+                   'std::string', 
+                   [], 
+                   is_virtual=True, is_const=True)
+    ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<const ns3::MobilityModel>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<const ns3::MobilityModel> arg0) [member operator]
+    cls.add_method('operator()', 
+                   'void', 
+                   [param('ns3::Ptr< ns3::MobilityModel const >', 'arg0')], 
+                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+    return
+
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Const_ns3Address___amp___Const_ns3Address___amp___Ns3NetDevicePacketType_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
     ## callback.h (module 'core'): ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, const ns3::Address &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty>::CallbackImpl() [constructor]
     cls.add_constructor([])
@@ -6137,7 +6783,7 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, const ns3::Address &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::NetDevice> arg0, ns3::Ptr<const ns3::Packet> arg1, short unsigned int arg2, ns3::Address const & arg3, ns3::Address const & arg4, ns3::NetDevice::PacketType arg5) [member operator]
     cls.add_method('operator()', 
                    'void', 
@@ -6159,7 +6805,7 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_const=True, is_virtual=True)
+                   is_virtual=True, is_const=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::NetDevice> arg0) [member operator]
     cls.add_method('operator()', 
                    'void', 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/examples/buildings-pathloss-profiler.cc ns-3.31/src/buildings/examples/buildings-pathloss-profiler.cc
--- ns-3.30.1/src/buildings/examples/buildings-pathloss-profiler.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/examples/buildings-pathloss-profiler.cc	2020-06-27 17:38:30.000000000 -0700
@@ -41,7 +41,7 @@
   double hUe = 1.0;
   bool enbIndoor = false;
   bool ueIndoor = false;
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   
   cmd.AddValue("hEnb", "Height of the eNB", hEnb);
   cmd.AddValue("hUe", "Height of UE", hUe);
@@ -75,7 +75,7 @@
   
   Ptr<MobilityBuildingInfo> buildingInfoEnb = CreateObject<MobilityBuildingInfo> ();
   mmEnb->AggregateObject (buildingInfoEnb); // operation usually done by BuildingsHelper::Install
-  BuildingsHelper::MakeConsistent (mmEnb);
+  buildingInfoEnb->MakeConsistent (mmEnb);
   
   Ptr<HybridBuildingsPropagationLossModel> propagationLossModel = CreateObject<HybridBuildingsPropagationLossModel> ();
   // cancel shadowing effect
@@ -92,7 +92,7 @@
       mmUe->SetPosition (Vector (i, 0.0, hUe));
       Ptr<MobilityBuildingInfo> buildingInfoUe = CreateObject<MobilityBuildingInfo> ();
       mmUe->AggregateObject (buildingInfoUe); // operation usually done by BuildingsHelper::Install
-      BuildingsHelper::MakeConsistent (mmUe);
+      buildingInfoUe->MakeConsistent (mmUe);
       double loss = propagationLossModel->GetLoss (mmEnb, mmUe);
       outFile << i << "\t"
               << loss 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/examples/outdoor-random-walk-example.cc ns-3.31/src/buildings/examples/outdoor-random-walk-example.cc
--- ns-3.30.1/src/buildings/examples/outdoor-random-walk-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/buildings/examples/outdoor-random-walk-example.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,130 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2012 Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)
+ * Copyright (c) 2019, University of Padova, Dep. of Information Engineering, SIGNET lab
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Nicola Baldo <nbaldo@cttc.es> for the code adapted from the lena-dual-stripe.cc example
+ * Author: Michele Polese <michele.polese@gmail.com> for this version
+ */
+
+#include "ns3/buildings-module.h"
+#include "ns3/mobility-module.h"
+#include "ns3/core-module.h"
+#include "ns3/network-module.h"
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE ("OutdoorRandomWalkExample");
+
+void
+PrintGnuplottableBuildingListToFile (std::string filename)
+{
+  std::ofstream outFile;
+  outFile.open (filename.c_str (), std::ios_base::out | std::ios_base::trunc);
+  if (!outFile.is_open ())
+    {
+      NS_LOG_ERROR ("Can't open file " << filename);
+      return;
+    }
+  uint32_t index = 0;
+  for (BuildingList::Iterator it = BuildingList::Begin (); it != BuildingList::End (); ++it)
+    {
+      ++index;
+      Box box = (*it)->GetBoundaries ();
+      outFile << "set object " << index
+              << " rect from " << box.xMin  << "," << box.yMin
+              << " to "   << box.xMax  << "," << box.yMax
+              << std::endl;
+    }
+}
+
+
+/**
+ * This is an example on how to use the RandomWalk2dOutdoorMobilityModel class.
+ * The script outdoor-random-walk-example.sh can be used to visualize the 
+ * positions visited by the random walk.
+ */
+int
+main (int argc, char *argv[])
+{
+  LogComponentEnable ("RandomWalk2dOutdoor", LOG_LEVEL_LOGIC);
+  CommandLine cmd (__FILE__);
+  cmd.Parse (argc, argv);
+
+  // create a grid of buildings
+  double buildingSizeX = 100;       // m
+  double buildingSizeY = 50; // m
+  double streetWidth = 25; // m
+  double buildingHeight = 10; // m
+  uint32_t numBuildingsX = 10;
+  uint32_t numBuildingsY = 10;
+  double maxAxisX = (buildingSizeX + streetWidth) * numBuildingsX;
+  double maxAxisY = (buildingSizeY + streetWidth) * numBuildingsY;
+
+  std::vector<Ptr<Building> > buildingVector;
+  for (uint32_t buildingIdX = 0; buildingIdX < numBuildingsX; ++buildingIdX)
+    {
+      for (uint32_t buildingIdY = 0; buildingIdY < numBuildingsY; ++buildingIdY)
+        {
+          Ptr < Building > building;
+          building = CreateObject<Building> ();
+
+          building->SetBoundaries (Box (buildingIdX * (buildingSizeX + streetWidth),
+                                        buildingIdX * (buildingSizeX + streetWidth) + buildingSizeX,
+                                        buildingIdY * (buildingSizeY + streetWidth),
+                                        buildingIdY * (buildingSizeY + streetWidth) + buildingSizeY,
+                                        0.0, buildingHeight));
+          building->SetNRoomsX (1);
+          building->SetNRoomsY (1);
+          building->SetNFloors (1);
+          buildingVector.push_back (building);
+        }
+    }
+
+  // print the list of buildings to file
+  PrintGnuplottableBuildingListToFile ("buildings.txt");
+
+  // create one node
+  NodeContainer nodes;
+  nodes.Create (1);
+
+  // set the RandomWalk2dOutdoorMobilityModel mobility model
+  MobilityHelper mobility;
+  mobility.SetMobilityModel ("ns3::RandomWalk2dOutdoorMobilityModel",
+                             "Bounds", RectangleValue (
+                               Rectangle (-streetWidth, maxAxisX, -streetWidth, maxAxisY)));
+  // create an OutdoorPositionAllocator and set its boundaries to match those of the mobility model
+  Ptr<OutdoorPositionAllocator> position = CreateObject<OutdoorPositionAllocator> ();
+  Ptr<UniformRandomVariable> xPos = CreateObject<UniformRandomVariable>();
+  xPos->SetAttribute ("Min", DoubleValue (-streetWidth));
+  xPos->SetAttribute ("Max", DoubleValue (maxAxisX));
+  Ptr<UniformRandomVariable> yPos = CreateObject<UniformRandomVariable>();
+  yPos->SetAttribute ("Min", DoubleValue (-streetWidth));
+  yPos->SetAttribute ("Max", DoubleValue (maxAxisY));
+  position->SetAttribute ("X", PointerValue (xPos));
+  position->SetAttribute ("Y", PointerValue (yPos));
+  mobility.SetPositionAllocator (position);
+  // install the mobility model
+  mobility.Install (nodes.Get (0));
+
+  // enable the traces for the mobility model
+  AsciiTraceHelper ascii;
+  MobilityHelper::EnableAsciiAll (ascii.CreateFileStream ("mobility-trace-example.mob"));
+
+  Simulator::Stop (Seconds (1e4));
+  Simulator::Run ();
+  Simulator::Destroy ();
+}
\ No newline at end of file
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/examples/wscript ns-3.31/src/buildings/examples/wscript
--- ns-3.30.1/src/buildings/examples/wscript	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/examples/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -4,3 +4,6 @@
     obj = bld.create_ns3_program('buildings-pathloss-profiler',
                                  ['buildings'])
     obj.source = 'buildings-pathloss-profiler.cc'
+    obj = bld.create_ns3_program('outdoor-random-walk-example',
+                                 ['buildings'])
+    obj.source = 'outdoor-random-walk-example.cc'
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/helper/building-position-allocator.cc ns-3.31/src/buildings/helper/building-position-allocator.cc
--- ns-3.30.1/src/buildings/helper/building-position-allocator.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/helper/building-position-allocator.cc	2020-06-27 17:38:30.000000000 -0700
@@ -330,7 +330,7 @@
       NS_ASSERT_MSG (mm, "no mobility model aggregated to this node");
       Ptr<MobilityBuildingInfo> bmm = mm->GetObject <MobilityBuildingInfo> ();
       NS_ASSERT_MSG (bmm, "MobilityBuildingInfo has not been aggregated to this node mobility model");
-      BuildingsHelper::MakeConsistent (mm);
+      bmm->MakeConsistent (mm);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/helper/buildings-helper.cc ns-3.31/src/buildings/helper/buildings-helper.cc
--- ns-3.30.1/src/buildings/helper/buildings-helper.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/helper/buildings-helper.cc	2020-06-27 17:38:30.000000000 -0700
@@ -53,6 +53,7 @@
       NS_ABORT_MSG_UNLESS (0 != model, "node " << node->GetId () << " does not have a MobilityModel");
 
     }
+
   Ptr<MobilityBuildingInfo> buildingInfo = CreateObject<MobilityBuildingInfo> ();
   model->AggregateObject (buildingInfo);
 }
@@ -67,9 +68,9 @@
       Ptr<MobilityModel> mm = (*nit)->GetObject<MobilityModel> ();
       if (mm != 0)
         {
-          MakeConsistent (mm);
           Ptr<MobilityBuildingInfo> bmm = mm->GetObject<MobilityBuildingInfo> ();
           NS_ABORT_MSG_UNLESS (0 != bmm, "node " << (*nit)->GetId () << " has a MobilityModel that does not have a MobilityBuildingInfo");
+          bmm->MakeConsistent (mm);
         }
     }
 }
@@ -87,13 +88,13 @@
       if ((*bit)->IsInside (pos))
         {
           NS_LOG_LOGIC ("MobilityBuildingInfo " << bmm << " pos " << mm->GetPosition () << " falls inside building " << (*bit)->GetId ());
-          NS_ABORT_MSG_UNLESS (found == false, " MobilityBuildingInfo already inside another building!");		
+          NS_ABORT_MSG_UNLESS (found == false, " MobilityBuildingInfo already inside another building!");
           found = true;
           uint16_t floor = (*bit)->GetFloor (pos);
           uint16_t roomX = (*bit)->GetRoomX (pos);
-          uint16_t roomY = (*bit)->GetRoomY (pos);	   
-          bmm->SetIndoor (*bit, floor, roomX, roomY);	      
-        }		    	  
+          uint16_t roomY = (*bit)->GetRoomY (pos);
+          bmm->SetIndoor (*bit, floor, roomX, roomY);
+        }
     }
   if (!found)
     {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/helper/buildings-helper.h ns-3.31/src/buildings/helper/buildings-helper.h
--- ns-3.30.1/src/buildings/helper/buildings-helper.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/helper/buildings-helper.h	2020-06-27 17:38:30.000000000 -0700
@@ -49,20 +49,29 @@
   */
   static void Install (NodeContainer c);     // for any nodes
   /**
-  * This method goes through the whole NodeList and, for each node in
+  * \brief This method goes through the whole NodeList and, for each node in
   * the list, calls BuildingsHelper::MakeConsistent() passing to it
-  * the MobilityModel of that node. 
+  * the MobilityModel of that node.
+  *
+  * \deprecated This method will go away in future release of ns-3.
+  * A node position will be make consistent by the method \c IsInside () of
+  * \c MobilityBuildingInfo class.
   *
   */
+  NS_DEPRECATED_3_31
   static void MakeMobilityModelConsistent ();
   /**
-  * Make the given mobility model consistent, by determining whether
-  * its position falls inside any of the building in BuildingList, and
-  * updating accordingly the BuildingInfo aggregated with the MobilityModel.
-  *
-  * \param bmm the mobility model to be made consistent
-  */
-  static void MakeConsistent (Ptr<MobilityModel> bmm);
+   * \brief Make the given mobility model consistent, by determining whether
+   * its position falls inside any of the building in BuildingList, and
+   * updating accordingly the BuildingInfo aggregated with the MobilityModel.
+   *
+   * \param mm the mobility model to be made consistent
+   *
+   * \deprecated This method will go away in future release of ns-3.
+   * See instead \c MakeConsistent method of \c MobilityBuildingInfo class.
+   */
+  NS_DEPRECATED
+  static void MakeConsistent (Ptr<MobilityModel> mm);
   
 };
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/model/building.cc ns-3.31/src/buildings/model/building.cc
--- ns-3.30.1/src/buildings/model/building.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/model/building.cc	2020-06-27 17:38:30.000000000 -0700
@@ -284,5 +284,11 @@
   return n;
 }
 
+bool
+Building::IsIntersect (const Vector &l1, const Vector &l2) const
+{
+  return m_buildingBounds.IsIntersect (l1, l2);
+}
+
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/model/building.h ns-3.31/src/buildings/model/building.h
--- ns-3.30.1/src/buildings/model/building.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/buildings/model/building.h	2020-06-27 17:38:30.000000000 -0700
@@ -200,6 +200,15 @@
    * \return  the floor where the position falls
    */
   uint16_t GetFloor (Vector position) const;
+  /**
+   * \brief Checks if a line-segment between position l1 and position l2
+   *        intersects a building.
+   *
+   * \param l1 position
+   * \param l2 position
+   * \return true if there is a intersection, false otherwise
+   */
+  bool IsIntersect (const Vector &l1, const Vector &l2) const;
 
 
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/model/buildings-channel-condition-model.cc ns-3.31/src/buildings/model/buildings-channel-condition-model.cc
--- ns-3.30.1/src/buildings/model/buildings-channel-condition-model.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/buildings/model/buildings-channel-condition-model.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,131 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2015, NYU WIRELESS, Tandon School of Engineering, New York
+ * University
+ * Copyright (c) 2019 SIGNET Lab, Department of Information Engineering,
+ * University of Padova
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#include "ns3/buildings-channel-condition-model.h"
+#include "ns3/mobility-model.h"
+#include "ns3/mobility-building-info.h"
+#include "ns3/building-list.h"
+#include "ns3/log.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("BuildingsChannelConditionModel");
+
+NS_OBJECT_ENSURE_REGISTERED (BuildingsChannelConditionModel);
+
+TypeId
+BuildingsChannelConditionModel::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::BuildingsChannelConditionModel")
+    .SetParent<ChannelConditionModel> ()
+    .SetGroupName ("Buildings")
+    .AddConstructor<BuildingsChannelConditionModel> ()
+  ;
+  return tid;
+}
+
+BuildingsChannelConditionModel::BuildingsChannelConditionModel ()
+  : ChannelConditionModel ()
+{
+}
+
+BuildingsChannelConditionModel::~BuildingsChannelConditionModel ()
+{
+}
+
+Ptr<ChannelCondition>
+BuildingsChannelConditionModel::GetChannelCondition (Ptr<const MobilityModel> a,
+                                                     Ptr<const MobilityModel> b) const
+{
+  Ptr<MobilityBuildingInfo> a1 = a->GetObject<MobilityBuildingInfo> ();
+  Ptr<MobilityBuildingInfo> b1 = b->GetObject<MobilityBuildingInfo> ();
+  NS_ASSERT_MSG ((a1 != nullptr) && (b1 != nullptr),
+                 "BuildingsChannelConditionModel only works with MobilityBuildingInfo");
+
+  Ptr<ChannelCondition> cond = CreateObject<ChannelCondition> ();
+
+  bool isAIndoor = a1->IsIndoor ();
+  bool isBIndoor = b1->IsIndoor ();
+
+
+  if (!isAIndoor && !isBIndoor) // a and b are outdoor
+    {
+      // The outdoor case, determine LOS/NLOS
+      // The channel condition should be LOS if the line of sight is not blocked,
+      // otherwise NLOS
+      bool blocked = IsLineOfSightBlocked (a->GetPosition (), b->GetPosition ());
+      if (!blocked)
+        {
+          cond->SetLosCondition (ChannelCondition::LosConditionValue::LOS);
+        }
+      else
+        {
+          cond->SetLosCondition (ChannelCondition::LosConditionValue::NLOS);
+        }
+
+    }
+  else if (isAIndoor && isBIndoor) // a and b are indoor
+    {
+      // Indoor case, determine is the two nodes are inside the same building
+      // or not
+      if (a1->GetBuilding () == b1->GetBuilding ())
+        {
+          cond->SetLosCondition (ChannelCondition::LosConditionValue::LOS);
+        }
+      else
+        {
+          cond->SetLosCondition (ChannelCondition::LosConditionValue::NLOS);
+        }
+    }
+  else //outdoor to indoor case
+    {
+      cond->SetLosCondition (ChannelCondition::LosConditionValue::NLOS);
+    }
+
+  return cond;
+}
+
+bool
+BuildingsChannelConditionModel::IsLineOfSightBlocked (const ns3::Vector &l1, const ns3::Vector &l2) const
+{
+  for (BuildingList::Iterator bit = BuildingList::Begin (); bit != BuildingList::End (); ++bit)
+    {
+      if ((*bit)->IsIntersect (l1, l2))
+        {
+          // The line of sight should be blocked if the line-segment between
+          // l1 and l2 intersects one of the buildings.
+          return true;
+        }
+    }
+
+  // The line of sight should not be blocked if the line-segment between
+  // l1 and l2 did not intersect any building.
+  return false;
+}
+
+int64_t
+BuildingsChannelConditionModel::AssignStreams (int64_t stream)
+{
+  NS_UNUSED (stream);
+  return 0;
+}
+
+} // end namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/buildings/model/buildings-channel-condition-model.h ns-3.31/src/buildings/model/buildings-channel-condition-model.h
--- ns-3.30.1/src/buildings/model/buildings-channel-condition-model.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/buildings/model/buildings-channel-condition-model.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,94 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2015, NYU WIRELESS, Tandon School of Engineering, New York
+ * University
+ * Copyright (c) 2019 SIGNET Lab, Department of Information Engineering,
+ * University of Padova
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#ifndef BUILDINGS_CHANNEL_CONDITION_MODEL_H
+#define BUILDINGS_CHANNEL_CONDITION_MODEL_H
+
+#include "ns3/channel-condition-model.h"
+
+namespace ns3 {
+
+class MobilityModel;
+
+/**
+ * \ingroup buildings
+ *
+ * \brief Determines the channel condition based on the buildings deployed in the
+ * scenario
+ *
+ * Code adapted from MmWave3gppBuildingsPropagationLossModel
+ */
+class BuildingsChannelConditionModel : public ChannelConditionModel
+{
+public:
+  /**
+   * Get the type ID.
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+
+  /**
+   * Constructor for the BuildingsChannelConditionModel class
+   */
+  BuildingsChannelConditionModel ();
+
+  /**
+   * Destructor for the BuildingsChannelConditionModel class
+   */
+  virtual ~BuildingsChannelConditionModel () override;
+
+  /**
+   * Computes the condition of the channel between a and b.
+   *
+   * \param a mobility model
+   * \param b mobility model
+   * \return the condition of the channel between a and b
+   */
+  virtual Ptr<ChannelCondition> GetChannelCondition (Ptr<const MobilityModel> a, Ptr<const MobilityModel> b) const override;
+
+  /**
+   * If this model uses objects of type RandomVariableStream,
+   * set the stream numbers to the integers starting with the offset
+   * 'stream'. Return the number of streams (possibly zero) that
+   * have been assigned.
+   *
+   * \param stream
+   * \return the number of stream indices assigned by this model
+   */
+  virtual int64_t AssignStreams (int64_t stream) override;
+
+private:
+  /**
+   * \brief Checks if the line of sight between position l1 and position l2 is
+   *        blocked by a building.
+   *
+   * \param l1 position
+   * \param l2 position
+   * \return true if the line of sight is blocked, false otherwise
+   */
+  bool IsLineOfSightBlocked (const Vector &l1, const Vector &l2) const;
+};
+
+} // end ns3 namespace
+
+#endif /* BUILDINGS_CHANNEL_CONDITION_MODEL_H */
